/****************************************************************************/
/**  vjbox  Fr diesen Child-Prozess wichtige Routinen (hauptschleife etc) **/
/**                                                                        **/
/** Copyright (C) 1997 Jochen Tillmann-Sarrazin, DG6VJ                     **/
/** All rights reserved.                                                   **/
/****************************************************************************/


#include "global.h"
#include "config.h"

char str_error[] = "001 Error!\n";



void ChildTerminate()
{
  char tmp[500];
  pid_t pid;

  log_me();

  /* .pid - und .msg - File lschen */
  pid = getpid();
  sprintf(tmp,"%s/userdata/%i.pid",boxroot,pid);
  unlink(tmp);
  sprintf(tmp,"%s/userdata/%i.msg",boxroot,pid);
  unlink(tmp);

  /* Den Speicher fr die boards-Liste wieder freigeben */
  close_boards_box();

  close(child_fd);
  _exit(0);
}





/* Groe Hauptschleife fr diesen Prozess. Sie wird nie verlassen. */
void hauptschleife()
{
  fd_set fd_mask;
  char str[500],tmp[500],param[500];
  int count;
  int cmd,fd;
  struct timeval tv;
  FILE *fs;
  
  /* Signalhandler, um einen Disconnect zu bemerken */
  signal(SIGTERM,(void *)ChildTerminate);
  signal(SIGKILL,(void *)ChildTerminate);
  
  
  /* Begrungsstring aussenden */
  sprintf(tmp,"200 vjboxd V%s (%s) Copyright (C) 1997-2000 Jochen Sarrazin, DG6VJ \n",
              VERSION,__DATE__);
  write(child_fd,tmp,strlen(tmp));
  
  /* Hat der User den Befehl LOGIN schon benutzt? Ohne knnen einige Befehle nicht benutzt
   * werden.
   */
  logged_in = FALSE;
  _randomize();
  
  for (;;) {
    FD_ZERO(&fd_mask);
    FD_SET(child_fd,&fd_mask);
    
    /* Alle 10 Sekunden gucken, ob was von anderen Prozessen angekommen ist. */
    tv.tv_usec = 0;
    tv.tv_sec = 2;
    
    if (select(child_fd+1,&fd_mask,NULL,NULL,&tv) == 0) {
      /* Zeitberschreitung - Gucken, ob fr uns Nachrichten vorliegen. */
      sprintf(tmp,"%s/userdata/%i.msg",boxroot,getpid());
      if ((fd = open(tmp,O_RDWR)) != -1) {
        /* Yo, es ist was da. - File locken. */
        lockit(fd,F_RDLCK,0,SEEK_SET,0);
        
        if ((fs = fdopen(fd,"r")) != NULL) {
          while (fgets(tmp,100,fs) != NULL) {
            sprintf(str,"099 %s",tmp);
            write(child_fd,str,strlen(str));
          }
        }

        ftruncate(fd,0);        
       
        /* File unlocken */
        lockit(fd,F_UNLCK,0,SEEK_SET,0);
        close(fd);
        sprintf(tmp,"%s/userdata/%i.msg",boxroot,getpid());
        unlink(tmp);
        
      }
    }
    
    /* Ja, da kommen Daten */
    if (FD_ISSET(child_fd,&fd_mask)) {
      count = read(child_fd,str,256);
      str[count] = '\0';
    
      if (count==0) ChildTerminate();
      
      if ((cmd = what_command(str,param)) == -1)
         write(child_fd,str_error,strlen(str_error));
      else {
      
        if ((child_udata.expect_pw[0] != '\0') && (cmd != 19)) {
          strcpy(tmp,"103 Sorry, access denied.\n");
          write(child_fd,tmp,strlen(tmp));
          ChildTerminate();
          return;
        }
      
        switch (cmd) {
          case 0: /* QUIT */
                  cmd_quit();
                  break;
          case 1: /* LOGIN */
                  cmd_login(param);
                  break;
          case 2: /* VERSION */
                  cmd_version();
                  break;
          case 3: /* PUTMAIL */
                  cmd_putmail(param);
                  break;
          case 4: /* NEWMAIL */
                  cmd_newmail(param);
                  break;
          case 5: /* GETMAIL */
                  cmd_getmail(param);
                  break;

          case 6: /* HEADER */
                  cmd_header(param);
                  break;
          case 10: /* BOARDLIST */
                   cmd_boardlist();
                   break;
          case 11: /* GETINFO */
                   cmd_getinfo(param);
                   break;
          case 12: /* NAME */
                   cmd_name(param);
                   break;
          case 13: /* READ */
                   cmd_read(param);
                   break;
          case 14: /* LIST */
                   cmd_list(param);
                   break;
          case 15: /* PASS */
                   cmd_pass(param);
                   break;
          case 17: /* PUT */
                   cmd_put(param);
                   break;
          case 18: /* CALLVALID */
                   cmd_callvalid(param);
                   break;
          case 19: /* DELETEBID */
                   cmd_deletebid(param);
                   break;
          case 20: /* CONFIG */
                   cmd_config(param);
                   break;
          case 21: /* BIDEXIST */
             	   cmd_bidexist(param);
                   break;
	case 22: cmd_put_header(param);
	  break;
	case 24: cmd_fwdack(param);
	  break;
	case 25: cmd_fwdlist(param);
	  break;
	case 26: cmd_fwdlock(param);
	  break;
	case 27: cmd_fwdunlock(param);
	  break;
	case 28: cmd_fwdack(param);
	  break;
        }
      }
    
    }
  
  }

}



int child_getline(char *str,int len)
{
  fd_set fd_mask;
  int count;
  
  FD_ZERO(&fd_mask);
  FD_SET(child_fd,&fd_mask);
  
  select(child_fd+1,&fd_mask,NULL,NULL,NULL);
  
  /* Ja, da kommen Daten */
  if (FD_ISSET(child_fd,&fd_mask)) {
    count = read(child_fd,str,len);

    if (count == 0) ChildTerminate();

    str[count] = '\0';
    
    return(count);
  }
}



